"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _XYZValues = _interopRequireDefault(require("./XYZValues"));

var _lowclass = _interopRequireDefault(require("lowclass"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (0, _lowclass.default)('XYZNumberValues').extends(_XYZValues.default, ({
  Super
}) => ({
  default: {
    x: 0,
    y: 0,
    z: 0
  },

  deserializeValue(prop, string) {
    return Number(string);
  },

  checkValue(prop, value) {
    if (!Super(this).checkValue(prop, value)) return false;
    if (typeof value !== 'number' || isNaN(value) || !isFinite(value)) throw new TypeError(`Expected ${prop} to be a finite number. Received: ${value}`);
    return true;
  }

}));

exports.default = _default;