"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _XYZStringValues = _interopRequireDefault(require("./XYZStringValues"));

var _lowclass = _interopRequireDefault(require("lowclass"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (0, _lowclass.default)('XYZSizeModeValues').extends(_XYZStringValues.default, ({
  Super
}) => ({
  default: {
    x: 'literal',
    y: 'literal',
    z: 'literal'
  },
  allowedValues: ['literal', 'proportional'],

  checkValue(prop, value) {
    if (!Super(this).checkValue(prop, value)) return false;
    if (!this.allowedValues.includes(value)) throw new TypeError(`Expected ${prop} to be one of 'literal' or 'proportional'. Received: '${value}'`);
    return true;
  }

}));

exports.default = _default;