"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lowclass = _interopRequireDefault(require("lowclass"));

var _BaseMeshBehavior = _interopRequireDefault(require("./BaseMeshBehavior"));

var _props = require("../../core/props");

var THREE = _interopRequireWildcard(require("three"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

window.THREE = THREE; // base class for geometry behaviors

var _default = (0, _lowclass.default)('BaseMaterialBehavior').extends(_BaseMeshBehavior.default, ({
  Super
}) => ({
  static: {
    type: 'material',
    props: {
      color: _props.props.THREE.Color,
      opacity: _objectSpread({}, _props.props.number, {
        default: 1
      })
    }
  },

  updated(oldProps, oldState, modifiedProps) {
    const {
      color,
      opacity
    } = modifiedProps;
    if (color) this.updateMaterial('color');

    if (opacity) {
      this.updateMaterial('opacity');
      this.updateMaterial('transparent');
    }
  },

  get transparent() {
    if (this.opacity < 1) return true;else return false;
  },

  updateMaterial(propName) {
    // if (this.element.tagName === 'I-SPHERE') debugger
    this.element.threeObject3d.material[propName] = this[propName];

    this.element._needsToBeRendered();
  }

}));

exports.default = _default;